#!/bin/bash
#module load global/testcluster
module load global/cluster
module load python/ana
source activate mpi4
module load openmpi/1.6.5

savupath=$1
datafile=$2
processfile=$3
outfile=$4
nCPUs=$5

export PYTHONPATH=$savupath:$PYTHONPATH
filename=$savupath/savu/dist_array_tomo_recon.py

UNIQHOSTS=${TMPDIR}/machines-u
awk '{print $1 }' ${PE_HOSTFILE} | uniq > ${UNIQHOSTS}
uniqslots=$(wc -l <${UNIQHOSTS})
echo "number of uniq hosts: ${uniqslots}"
echo "running on these hosts:"
cat ${UNIQHOSTS}

processes=`bc <<< "$((uniqslots*nCPUs))"`

nCPUs=$((nCPUs-1))
CPUs=CPU0

if [ $nCPUs -gt 0 ]; then
	for i in $(eval echo {1..$nCPUs})
  	do
		CPUs=$CPUs,CPU$i
	done
fi


echo "Processes running are : ${processes}"

mpirun -np ${processes} \
       -mca btl self,openib,sm \
       -mca orte_forward_job_control 1 \
       -x LD_LIBRARY_PATH \
       --hostfile ${UNIQHOSTS} \
       python $filename $datafile $processfile $outfile -n $CPUs

